"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @class
 * @classdesc a class that handles everything related to the website
 * */
var Adhara = null;

(function () {
    var AdharaBase = function () {
        function AdharaBase() {
            _classCallCheck(this, AdharaBase);
        }

        _createClass(AdharaBase, [{
            key: "init",
            value: function init(app) {
                callOnInitListeners();
                this.always_active_views = [];
                this.active_views = [];
                if (app) {
                    this.app = new app();
                    this.createShortcuts();
                    this.performSystemChecks();
                    this.createContainer();
                } else {
                    AdharaRouter.route();
                }
            }
        }, {
            key: "createShortcuts",
            value: function createShortcuts() {
                var _this = this;

                //Creating a view_name vs context_name map
                this.view_context = {};
                loop(this.app.config, function (context_name, configuration) {
                    if (configuration.hasOwnProperty("view") && AdharaView.isPrototypeOf(configuration.view)) {
                        _this.view_context[configuration.view.name] = context_name;
                    }
                });
            }
        }, {
            key: "performSystemChecks",
            value: function performSystemChecks() {
                /*// verify the controller for if it has support for all the API methods (for ease of Dev)
                for(let i = 0; i < Adhara.app.allowedHttpMethods.length; i++){
                    if(typeof Controller[Adhara.app.allowedHttpMethods[i] + "Data"] !== 'function'){
                        throw new Error(Adhara.app.allowedHttpMethods[i] + " api method is not registered with the controller!");
                    }
                }*/
            }
        }, {
            key: "createContainer",
            value: function createContainer() {
                AdharaRouter.configure(this.app.routerConfiguration);
                AdharaRouter.listen();
                if (this.app.containerView) {
                    this.container = new this.app.containerView();
                    this.container.onViewRendered(AdharaRouter.route);
                    this.always_active_views = this.container.subViews.map(function (subView) {
                        return Adhara.getView(subView);
                    });
                    this.always_active_views.push(this.container);
                    this.clearActiveViews();
                    Adhara.createView(this.container);
                } else {
                    this.clearActiveViews();
                    AdharaRouter.route();
                }
            }
        }, {
            key: "addToActiveViews",
            value: function addToActiveViews(viewInstance) {
                this.active_views.push(viewInstance);
            }
        }, {
            key: "isActiveView",
            value: function isActiveView(viewInstance) {
                return this.active_views.indexOf(viewInstance) !== -1;
            }
        }, {
            key: "clearActiveViews",
            value: function clearActiveViews() {
                this.active_views = this.always_active_views.slice();
            }
        }, {
            key: "viewHierarchy",
            get: function get() {
                return [AdharaContainerView, AdharaDialogView, AdharaTemplateView, AdharaCardView, AdharaGridView, AdharaListView, AdharaFormView, AdharaView];
            }
        }]);

        return AdharaBase;
    }();

    Adhara = new AdharaBase();

    Adhara.getView = function (viewClass, parentViewInstance) {
        if (!viewClass) {
            throw new Error("invalid view class");
        }
        if (viewClass instanceof Function) {
            return Adhara.instances[viewClass.name] || new viewClass(parentViewInstance);
        }
        return Adhara.instances[viewClass.constructor.name] || new viewClass(parentViewInstance);
    };

    Adhara.createView = function (adhara_view_instance) {
        adhara_view_instance.create();
    };

    Adhara.onRoute = function (view_class) {
        Adhara.clearActiveViews();
        Adhara.createView(Adhara.getView(view_class, Adhara.container));
    };

    var on_init_listeners = [];
    Adhara.onInit = function (fn) {
        on_init_listeners.push(fn);
    };

    function callOnInitListeners() {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = on_init_listeners[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var on_init_listener = _step.value;

                on_init_listener();
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }

    Adhara.instances = {};
})();
//# sourceMappingURL=Adhara.js.map