"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AdharaListView = function (_AdharaView) {
    _inherits(AdharaListView, _AdharaView);

    function AdharaListView() {
        _classCallCheck(this, AdharaListView);

        return _possibleConstructorReturn(this, (AdharaListView.__proto__ || Object.getPrototypeOf(AdharaListView)).apply(this, arguments));
    }

    _createClass(AdharaListView, [{
        key: "onInit",
        value: function onInit() {
            this._page_number = 0;
        }
    }, {
        key: "onPreviousPage",


        /**
         * @function
         * @instance
         * @description listens to the previous page request, and triggers the Page Change Listener
         * */
        value: function onPreviousPage() {
            this._page_number = this.pageNumber - this.rowCount;
            this.pageChange();
        }

        /**
         * @function
         * @instance
         * @description listens to the next page request, and triggers the Page Change Listener
         * */

    }, {
        key: "onNextPage",
        value: function onNextPage() {
            this._page_number = this.pageNumber + this.rowCount;
            this.pageChange();
        }

        /**
         * @function
         * @instance
         * @description will be called on page change
         * */

    }, {
        key: "pageChange",
        value: function pageChange() {
            this.fetchData();
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-list";
        }

        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate} template of the list structure
         * */

    }, {
        key: "listTemplate",
        get: function get() {
            throw new Error("override `get listTemplate`");
        }

        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate} template of the list header
         * */

    }, {
        key: "headerTemplate",
        get: function get() {
            throw new Error("override `get headerTemplate`");
        }

        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} template of a list item
         * */

    }, {
        key: "itemTemplate",
        get: function get() {
            throw new Error("override `get itemTemplate`");
        }

        /**
         * @method
         * @getter
         * @returns {String} Table title that is to be rendered
         * */

    }, {
        key: "title",
        get: function get() {
            return "";
        }

        /**
         * @method
         * @getter
         * @returns {Boolean} whether to enable pagination or not
         * */

    }, {
        key: "isPaginationRequired",
        get: function get() {
            return false;
        }

        /**
         * @typedef {Object} ColumnConfig
         * @property {String} key - column key
         * @property {String} name - column name that is to be rendered
         * @property {Boolean} trust_as_html - whether to render as text content or HTML content
         * @example
         * {
         *  key: "column_key",
         *  name: "Column Name",
         *  trust_as_html: false // whether to render HTML as buttons or not
         * }
         * */

        /**
         * @method
         * @getter
         * @returns {Array<ColumnConfig>} list of columns in the format of column configuration
         * */

    }, {
        key: "columns",
        get: function get() {
            return [];
        }
    }, {
        key: "noDataAvailable",
        get: function get() {
            return "No Data Available";
        }

        /**
         * @function
         * @getter
         * @returns {Boolean} whether add new button is required or not
         * */

    }, {
        key: "addNew",
        get: function get() {
            return false;
        }

        /**
         * @function
         * @getter
         * @returns {Number} total row count in a page
         * */

    }, {
        key: "rowCount",
        get: function get() {
            return AdharaListView.rowCount;
        }

        /**
         * @function
         * @getter
         * @returns {Number} the start index of the current page
         * */

    }, {
        key: "pageNumber",
        get: function get() {
            return this._page_number;
        }

        /**
         * @function
         * @getter
         * @returns {Boolean} if the current page is the first page
         * */

    }, {
        key: "isFirstPage",
        get: function get() {
            return !this._page_number;
        }

        /**
         * @function
         * @getter
         * @returns {Boolean} if the current page is the last page
         * */

    }, {
        key: "isLastPage",
        get: function get() {
            //Assumption: this.data is the only has the data for the current page
            return this.data.length < this.rowCount;
        }
    }, {
        key: "payload",
        get: function get() {
            return AdharaListView.getPagePayload(this.pageNumber);
        }
    }]);

    return AdharaListView;
}(AdharaView);

/**
 * @member {Number} default row count of all table instances. Default's 5.
 * Override to increase globally.
 * */


AdharaListView.rowCount = 5;

/**
 * @member {Function} Global function that implements pagePayload pattern for payload on pagination.
 * Recommended to override.
 * */
AdharaListView.getPagePayload = function (page) {
    return { page: page };
};
//# sourceMappingURL=ListView.js.map